/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.phone = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.phone.length != 11) {
			return callback('手机号为 11 个字符');
		}
		if (loginInfo.password.length < 6) {
			return callback('密码最短为 6 个字符');
		}
		var users = JSON.parse(localStorage.getItem('$users') || '[]');
		var authed = users.some(function(user) {
			return loginInfo.phone == user.phone && loginInfo.password == user.password;
		});
		if (authed) {
			return owner.createState(loginInfo.phone, callback);
		} else {
			return callback('用户名或密码错误');
		}
		var data = owner.getInfo();
		data.phone = loginInfo.phone;
		data.password = loginInfo.password;
	   
	}
	
	owner.createState = function(phone, callback) {
		var state = owner.getState();
		state.phone = phone;
		state.token = "token123456789";
		owner.setState(state);
		return callback();
	};
	
	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
//		if (!checkEmail(email)) {
//			return callback('邮箱地址不合法');
//		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
			var settingsText = localStorage.getItem('$settings') || "{}";
			return JSON.parse(settingsText);
	}
	
	owner.getData = function(){
		var stateText = localStorage.getItem('$data') || "{}";
		return JSON.parse(stateText);
	}
	
	owner.setData = function(data){
		data = data || {};
		localStorage.setItem('$data', JSON.stringify(data));
	}
	/**
	 * 获取设备信息 
	 */
	owner.getInfo = function(){
		var uuid = plus.device.uuid;
		var model = plus.device.model;
		var systemName = plus.os.name;
		var systemVersion = plus.os.version;
		var systemLanguage = plus.os.language;
		var longtitude ="";//plus.Coordinates.longitude;
		var latitude ="";// plus.Coordinates.latitude;
		var altitude ="";// plus.Coordinates.altitude;
		var province ="";// plus.Address.province;
		var city = "";//plus.Address.city;
		var district = "";//plus.Address.district;
		var info = {
				"uuid":uuid ,
				"model": model,
				"systemName": systemName,
				"systemVersion": systemVersion,
				"systemLanguage": systemLanguage,
				"longtitude": longtitude,
				"latitude": latitude,
				"altitude": altitude,
				"province":province, 
				"city": city,
				"district": district
		};
		return info;
	}
}(mui, window.app = {}));